#!/usr/bin/env ruby
require 'sensu-plugin/check/cli'
require 'mixlib/shellout'
require 'json'

class RallyRunTask < Sensu::Plugin::Check::CLI

  option :task,
    :short => '-t TASK',
    :long => '--task',
    :description => 'The Task which should be ran'

  #
  # option :crit,
  #   :short => '-c CRIT',
  #   :proc => proc {|a| a.to_i },
  #   :default => 5

  def run
    src_rally = ". /opt/sensu/rally/bin/activate; "
    cmd = "rally task start --task /opt/sensu/rally/#{config[:task]}.json --deployment testbed_b"
    cmd.prepend(src_rally)
    cmd = Mixlib::ShellOut.new(cmd)
    cmd.run_command
    critical "1 #{cmd.stdout} ---Error-Message---\n#{cmd.stderr}" if cmd.error?
    result = cmd.stdout.split("\n").last
    if result[0] == '\\'
      result = result[1..-1]
    end
    result.prepend(src_rally)
    result_cmd = Mixlib::ShellOut.new(result)
    result_cmd.run_command
    result_hash = JSON.parse(result_cmd.stdout)[0]
    critical "2 #{result_hash['result'][0]['error']} ---Std-Out---\n#{cmd.stdout}" unless result_hash['result'][0]['error'] && result_hash['result'][0]['error'] == []
    ok result_hash
  end
end